"use strict";

var _babelTemplate = require("babel-template");

var _babelTemplate2 = _interopRequireDefault(_babelTemplate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = function (_ref) {
  var t = _ref.types;

  return {
    visitor: {
      ClassDeclaration: function ClassDeclaration(path) {
        if (!(t.isIdentifier(path.node.id) && t.isIdentifier(path.node.superClass))) {
          return;
        }

        var runOnInheritedHook = (0, _babelTemplate2.default)("\n          if (SUPER.hasOwnProperty(\"onInherited\")) {\n            if (typeof SUPER.onInherited == 'function') {\n              SUPER.onInherited(CHILD);\n            } else {\n              throw new TypeError(\"Attempted to call onInherited, but it was not a function\");\n            }\n          }\n        ");

        var ast = runOnInheritedHook({
          SUPER: t.identifier(path.node.superClass.name),
          CHILD: t.identifier(path.node.id.name)
        });

        path.insertAfter(ast);
      }
    }
  };
};